/*
 * Stack.java
 *
 * Modified on pondelok, 3. 11. 2008, 1.30
 *
 */

package cz.muni.fi.pb162.stack;

/**
 * Dynamic data structure full-filling the Last in, First out (LIFO) principe
 * @author Michal Oprendek
 * @version 1.0
 */
public interface Stack<T> {
    
    /**
     * Inserts object on the top of the stack
     * @param o inserted object
     */
    void push(T o);
        
    /**
     * Checks whether the stack is empty or not
     * @return <CODE>true</CODE> if the stack is empty
     * <CODE>false</CODE> otherwise
     */
    boolean isEmpty();
    
    /**
     * Removes the object from the top of the stack
     * @return removed object
     */
    T pop();
    
    /**
     * Gives the object from the top of the stack withou removing it
     * @return the object on the top of the stack
     */
    T peek();
    
}
